// kit.cs

//some new prefs
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	
	RTB_registerPref("Display own team","Disguise","pref::dis::display","bool","Tool_DisguiseKit",1,0,0);
	RTB_registerPref("Smoke effect on disguise","Disguise","pref::dis::smoke","bool","Tool_DisguiseKit",1,0,0);
	RTB_registerPref("Sound on disguise","Disguise","pref::dis::sound","bool","Tool_DisguiseKit",1,0,0);
	RTB_registerPref("Disguise Time (in ms)","Disguise","pref::dis::time","int 100 5000","Tool_DisguiseKit",2500,0,0);
}
else
{
	$pref::dis::display = 1;
	$pref::dis::smoke = 1;
	$pref::dis::sound = 1;
	$pref::dis::time = 2500; //in ms
}

datablock itemData(disguiseKitSItem)
{
	category = "item";
	equipment = true;
	
	uiName = "Disguise Kit";
	iconName = "base/client/ui/plantErrors_small/plantError_teams";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";
	
	shapeFile = "base/data/shapes/brickWeapon.dts";
	emap = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	
	image = disguiseKitSImage;
	canDrop = true;
};

datablock shapeBaseImageData(disguiseKitSImage)
{
	className = "weaponImage";
	item = disguiseKitSItem;
	
	shapeFile = "base/data/shapes/brickWeapon.dts";
	emap = disguiseKitSItem.emap;
	doColorShift = disguiseKitSItem.doColorShift;
	colorShiftColor = disguiseKitSItem.colorShiftColor;
	
	mountPoint = 0;
	offset = "0 -0.05 0";
	rotation = "0 1 0 180";
	eyeOffset = "0.7 1.2 -0.8";
	eyeRotation = "0 1 0 180";
	
	correctMuzzleVector = false;
	
	melee = true;
	armReady = true;
	
	stateName[0]                    = "activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "ready";
	
	stateName[1]                    = "ready";
	stateTransitionOnTriggerDown[1] = "fire";
	stateAllowImageChange[1]        = true;
	 
	stateName[2]                    = "fire";
	stateTransitionOnTriggerUp[2]   = "ready";
	stateScript[2]                  = "onFire";
};

function disguiseKitSImage::onFire(%this, %player, %slot)
{
	if(!isObject(%player.client)) // Probably a bot. no wai
		return;
	
	%client = %player.client;
	
	if(%client.SlyrTeam == -1)
		return messageClient(%client, '', "\c0You must be in a team to use this!");
	
	%minigame = getMiniGameFromObject(%client);
	for(%i = 0;%i<%minigame.teams.getCount(); %i++)
	{
		if($pref::dis::display)
		{
			%c = "<color:" @ Slayer_Support::RGBToHEX(getColorIDTable(%minigame.teamCol[%i])) @ ">";
			messageClient(%client, '', %c @ %i + 1 @ "." SPC %minigame.teams.getObject(%i).name);
		}
		else
		{
			if(%minigame.teams.getObject(%i) != %client.getTeam())
			{
				%c = "<color:" @ Slayer_Support::RGBToHEX(getColorIDTable(%minigame.teamCol[%i])) @ ">";
				messageClient(%client, '', %c @ %i + 1 @ "." SPC %minigame.teams.getObject(%i).name);
			}
			else
				%team = %i;
		}
	}
	if(!$pref::dis::display)
		messageClient(%client, '',"<color:" @ Slayer_Support::RGBToHEX(getColorIDTable(%minigame.teamCol[%team])) @ ">" @ "0. Undisguise");
	
	messageClient(%client, '', "\c2Please enter the team's number.");
	%player.disguising = true;
}

package slayerDisguise
{
	function gameConnection::createPlayer(%this, %spawnPoint)
	{
		parent::createPlayer(%this, %spawnPoint);
		
		if(isObject(%this.player))
		{
			%this.player.disguising = false;
			%this.player.disguised = %this.getTeam();
			%this.player.disguiseSchedule = 0;
		}
	}
	
	function gameConnection::disguise(%this, %team)
	{
		%this.player.disguiseSchedule = 0;
		
		%this.player.disguised = %team; // Decide if we're undisguising or not.
		%oldTeam = %this.getTeam();
		
		%this.SlyrTeam = %team;
		%this.applyUniform(); // Cheap way to do this. --fu
		
		%this.SlyrTeam = %oldTeam;
		
		if($pref::dis::sound)
			ServerPlay3D(deathExplosionSound, %this.player.getPosition());
		%player.disguising = false;
	}
	
	function gameConnection::onDeath(%this, %sourceObject, %sourceClient, %damageType, %damageLoc)
	{
		if(isObject(%sourceObject) && %sourceObject.disguised != -1 && %sourceObject.disguised != %this.getTeam())
			%this.disguise(%this.getTeam());
		parent::onDeath(%this, %sourceObject, %sourceClient, %damageType, %damageLoc);
	}
	
	function gameConnection::applyUniform(%client)
	{
		if(isObject(%client.player) && %client.player.disguising && %client.player.disguised != %client.getTeam())
		{
			%hacking = true;
			%oldTeam = %client.getTeam();
			%client.SlyrTeam = %client.player.disguised;
		}
		parent::applyUniform(%client);
		if(%hacking)
			%client.SlyrTeam = %oldTeam;
	}
	
	function serverCmdmessageSent(%client, %text)
	{
		if(isObject(%player = %client.player) && (%client.player.disguising && !isEventPending(%client.player.disguiseSchedule)))
		{
			%minigame = getMiniGameFromObject(%client);
			if(%text==0)
			{
				%player.disguised = %client.getTeam();
				%client.applyUniform(); // Cheap way to do this.	
				messageClient(%client, '', "\c0You're now undisguised.");	
				return;
			}
			for(%i = 0;%i<%minigame.teams.getCount(); %i++)
				if(%text == %i + 1)
				{
					if(%player.disguised == %minigame.teams.getObject(%i))
					{
						if(%player.disguised == %client.SlyrTeam)
							messageClient(%client, '', "\c0You're already undisguised!");
						else
							messageClient(%client, '', "\c0You're already disguised as this team!");
						return;
					}
					
					if(%client.SlyrTeam == %minigame.teams.getObject(%i))
					{
						%player.disguised = %client.SlyrTeam;
						
						%client.applyUniform(); // Cheap way to do this.
						
						messageClient(%client, '', "\c0You're now undisguised.");
						return;
					}
					else
						messageClient(%client, '', '\c2Disguising as team %1\c2...', %minigame.teams.getObject(%i).name);
					if($pref::dis::smoke)
						%player.burn($pref::dis::time);
					%player.disguiseSchedule = %client.schedule($pref::dis::time, "disguise", %minigame.teams.getObject(%i));
					return;
				}
			messageClient(%client, '', "\c0Invalid team number!");
			%client.player.disguising = false;
			return;
		}
		parent::serverCmdmessageSent(%client, %text);
	}
	
	function projectile::onAdd(%this, %wtf)
	{
		if(isObject((%client = %this.client)) && isObject((%player = %client.player)) && %this.sourceObject == %player && %player.disguised != -1 && (%player.disguised != %client.SlyrTeam || isEventPending(%player.disguiseSchedule)))
		{
			%datablock = %this.getDatablock();
			%damage = %datablock.directDamage;
			if(isObject((%explosion = %datablock.explosion)))
				%damage += %explosion.radiusDamage;
			if(%damage > 0)
			{
				if(isEventPending(%player.disguiseSchedule))
				{
					cancel(%player.disguiseSchedule);
					if($pref::dis::smoke)
						%player.burn(0);
				}
				%player.disguised = %client.getTeam();
				%client.applyUniform(); // Cheap way to do this.
				messageClient(%client, '', "\c0You're now undisguised.");
			}
		}
		parent::onAdd(%this, %wtf);
	}
	
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		if(%obj.disguised != -1 && %triggerNum == 0)
		{
			if(%obj.disguised == %obj.client.getTeam() && !isEventPending(%obj.client.disguiseSchedule))
				return parent::onTrigger(%this, %obj, %triggerNum, %val);
			
			%client = %obj.client;
			%player = %obj;
						
			if(isObject(%weapon = %obj.getMountedImage(0)) && %weapon.melee && isObject(%weapon.projectile))
			{
				%damage = %weapon.projectile.directDamage;
				if(%damage > 0)
				{
					if(isEventPending(%player.disguiseSchedule))
					{
						cancel(%player.disguiseSchedule);
						if($pref::dis::smoke)
							%player.burn(0);
					}
					%player.disguised = %client.getTeam();
					messageClient(%client, '', "\c0You're now undisguised.");
				}
			}
		}
		parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(slayerDisguise);